/*
 * Example file showing a demo with 100 agents split in four groups initially
 * positioned in four corners of the environment. Each agent attempts to move to
 * other side of the environment through a narrow passage generated by four
 * obstacles. There is no roadmap to guide the agents around the obstacles.
 */

#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <vector>

#define _OPENMP
#ifdef _OPENMP
#include <omp.h>
#endif

#include "RVO.h"

#ifndef M_PI
const float M_PI = 3.14159265358979323846f;
#endif


// ROS Stuff
#include <ros/ros.h>
#include <geometry_msgs/Point.h>
#include <geometry_msgs/PolygonStamped.h>
#include <visualization_msgs/Marker.h>
#include <visualization_msgs/MarkerArray.h>
// #include <acl_msgs/Trajectory.h>

#include "AgentTraj.h"

/* Store the goals of the agents. */
std::vector<RVO::Vector2> goals;

void setupScenario(RVO::RVOSimulator *sim)
{
	/* Seed the random number generator. */
	std::srand(static_cast<unsigned int>(std::time(0)));

	/* Specify the global time step of the simulation. */
	sim->setTimeStep(0.05f);

	/* Specify the default parameters for agents that are subsequently added. */
	// neighborDist, maxNeighbors, timeHorizon, timeHorizonObst, radius, maxSpeed, (velocity)
	sim->setAgentDefaults(15.0f, 10, 1.0f, 1.0f, 0.25f, 2.5f);

	/*
	 * Add agents, specifying their start position, and store their goals on the
	 * opposite side of the environment.
	 */
	sim->addAgent(RVO::Vector2(0.8f,0.8f));
	sim->addAgent(RVO::Vector2(0.8f,-6.5f));
	sim->addAgent(RVO::Vector2(-1.5f,0.5f));
	sim->addAgent(RVO::Vector2(-7.0f,-2.5f));
	sim->addAgent(RVO::Vector2(-1.5f,-6.5f));
	sim->addAgent(RVO::Vector2(-7.0f,-6.4f));
	
	// sim->addAgent(RVO::Vector2(-10.0f,10.0f));
	// sim->addAgent(RVO::Vector2(10.0f,10.0f));
	// sim->addAgent(RVO::Vector2(10.0f,-10.0f));

	goals.push_back(RVO::Vector2(-7.0f,-6.4f));
	goals.push_back(RVO::Vector2(-7.0f,-2.5f));
	goals.push_back(RVO::Vector2(-1.5f,-6.5f));
	goals.push_back(RVO::Vector2(0.8f,-6.5f));
	goals.push_back(RVO::Vector2(-1.5f,0.5f));
	goals.push_back(RVO::Vector2(0.7f,0.7f));

	// goals.push_back(RVO::Vector2(10.0f,-10.0f));
	// goals.push_back(RVO::Vector2(-10.0f,-10.0f));
	// goals.push_back(RVO::Vector2(-10.0f,10.0f));

	// for (size_t i = 0; i < 5; ++i) {
	// 	for (size_t j = 0; j < 5; ++j) {
	// 		sim->addAgent(RVO::Vector2(55.0f + i * 10.0f,  55.0f + j * 10.0f));
	// 		goals.push_back(RVO::Vector2(-75.0f, -75.0f));

	// 		sim->addAgent(RVO::Vector2(-55.0f - i * 10.0f,  55.0f + j * 10.0f));
	// 		goals.push_back(RVO::Vector2(75.0f, -75.0f));

	// 		sim->addAgent(RVO::Vector2(55.0f + i * 10.0f, -55.0f - j * 10.0f));
	// 		goals.push_back(RVO::Vector2(-75.0f, 75.0f));

	// 		sim->addAgent(RVO::Vector2(-55.0f - i * 10.0f, -55.0f - j * 10.0f));
	// 		goals.push_back(RVO::Vector2(75.0f, 75.0f));
	// 	}
	// }

	/*
	 * Add (polygonal) obstacles, specifying their vertices in counterclockwise
	 * order.
	 */
	std::vector<RVO::Vector2> obstacle1, obstacle2;//, obstacle3, obstacle4;
	obstacle1.push_back(RVO::Vector2(-2.6f,-3.7f));
	obstacle1.push_back(RVO::Vector2(-3.9f,-3.7f));
	obstacle1.push_back(RVO::Vector2(-3.9f,-5.0f));
	obstacle1.push_back(RVO::Vector2(-2.6f,-5.0f));

	obstacle2.push_back(RVO::Vector2(1.1f, 1.0f));
	obstacle2.push_back(RVO::Vector2(1.1f, -6.9f));
	obstacle2.push_back(RVO::Vector2(-7.5f, -6.9f));
	obstacle2.push_back(RVO::Vector2(-7.5f, -1.8f));
	obstacle2.push_back(RVO::Vector2(-2.0f, -1.8f));
	obstacle2.push_back(RVO::Vector2(-2.0f, 1.0f));

	sim->addObstacle(obstacle1);
	sim->addObstacle(obstacle2);
	// /* Process the obstacles so that they are accounted for in the simulation. */
	sim->processObstacles();
}

geometry_msgs::Point toGeoMsgPoint(float x, float y){
	geometry_msgs::Point p;
	p.x = x;
	p.y = y;
	p.z = 0.0f;
	return p;
}


void updateVisualization(RVO::RVOSimulator *sim)
{
	/* Output the current global time. */
	std::cout << sim->getGlobalTime();

	/* Output the current position of all the agents. */
	for (size_t i = 0; i < sim->getNumAgents(); ++i) {
		std::cout << " " << sim->getAgentPosition(i);
	}

	std::cout << std::endl;
}

void setPreferredVelocities(RVO::RVOSimulator *sim)
{
	/*
	 * Set the preferred velocity to be a vector of unit magnitude (speed) in the
	 * direction of the goal.
	 */
#ifdef _OPENMP
#pragma omp parallel for
#endif
	for (int i = 0; i < static_cast<int>(sim->getNumAgents()); ++i) {
		RVO::Vector2 goalVector = goals[i] - sim->getAgentPosition(i);

		if (RVO::absSq(goalVector) > 1.0f) {
			goalVector = RVO::normalize(goalVector);
		}

		sim->setAgentPrefVelocity(i, 5.0f*goalVector);

		/*
		 * Perturb a little to avoid deadlocks due to perfect symmetry.
		 */
		float angle = std::rand() * 2.0f * M_PI / RAND_MAX;
		float dist = std::rand() * 0.0001f / RAND_MAX;

		sim->setAgentPrefVelocity(i, sim->getAgentPrefVelocity(i) +
		                          dist * RVO::Vector2(std::cos(angle), std::sin(angle)));
	}
}

bool reachedGoal(RVO::RVOSimulator *sim)
{
	/* Check if all agents have reached their goals. */
	for (size_t i = 0; i < sim->getNumAgents(); ++i) {
		if (RVO::absSq(sim->getAgentPosition(i) - goals[i]) > 0.05f * 0.05f) {
			return false;
		}
	}

	return true;
}

visualization_msgs::Marker getMarkers(RVO::RVOSimulator *sim)
{
	visualization_msgs::Marker marker;
	// Iterate over all agents
	for (size_t i = 0; i < sim->getNumAgents(); ++i) {
		RVO::Vector2 agentPos = sim->getAgentPosition(i);
		geometry_msgs::Point p;
		p.x = agentPos.x();
		p.y = agentPos.y();
		p.z = 0.0f;
		marker.points.push_back(p);
		// ROS_INFO_STREAM("Pos" << p);
	}

	// Fill in marker properties
	marker.header.frame_id = "vicon";
	marker.header.stamp = ros::Time::now();
	marker.ns = "agents";//ros::this_node::getName();
	marker.action = visualization_msgs::Marker::ADD;
	marker.id = 0;
	marker.lifetime = ros::Duration(0.5);
	marker.pose.orientation.w = 1.0;
	marker.type = visualization_msgs::Marker::SPHERE_LIST;
	marker.scale.x = 0.25f;
	marker.scale.y = 0.25f;
	marker.scale.z = 1.0f;
	// Marker color
	// rgb randomColor = get_color_by_id(id);
	marker.color.r = 0.0f;
	marker.color.g = 0.0f;
	marker.color.b = 1.0f;
	marker.color.a = 1.0f;
	return marker;
}

visualization_msgs::MarkerArray getObsMarkerArray()
{
	visualization_msgs::MarkerArray markerArray;

	visualization_msgs::Marker marker;
	marker.points.push_back(toGeoMsgPoint(-2.6f,-3.7f));
	marker.points.push_back(toGeoMsgPoint(-3.9f,-3.7f));
	marker.points.push_back(toGeoMsgPoint(-3.9f,-5.0f));
	marker.points.push_back(toGeoMsgPoint(-2.6f,-5.0f));
	marker.points.push_back(toGeoMsgPoint(-2.6f,-3.7f));
	marker.header.frame_id = "vicon";
	marker.header.stamp = ros::Time::now();
	marker.ns = "obstacle";//ros::this_node::getName();
	marker.action = visualization_msgs::Marker::ADD;
	marker.id = 0;
	marker.lifetime = ros::Duration(0);
	// marker.pose.orientation.w = 1.0;
	marker.type = visualization_msgs::Marker::LINE_STRIP;
	marker.scale.x = 0.1f;
	marker.color.r = 1.0f;
	marker.color.g = 0.0f;
	marker.color.b = 0.0f;
	marker.color.a = 1.0f;
	markerArray.markers.push_back(marker);

	visualization_msgs::Marker marker_2;
	marker_2.points.push_back(toGeoMsgPoint(1.1f, 1.0f));
	marker_2.points.push_back(toGeoMsgPoint(1.1f, -6.9f));
	marker_2.points.push_back(toGeoMsgPoint(-7.5f, -6.9f));
	marker_2.points.push_back(toGeoMsgPoint(-7.5f, -1.8f));
	marker_2.points.push_back(toGeoMsgPoint(-2.0f, -1.8f));
	marker_2.points.push_back(toGeoMsgPoint(-2.0f, 1.0f));
	marker_2.points.push_back(toGeoMsgPoint(1.1f, 1.0f));
	marker_2.header.frame_id = "vicon";
	marker_2.header.stamp = ros::Time::now();
	marker_2.ns = "obstacle";//ros::this_node::getName();
	marker_2.action = visualization_msgs::Marker::ADD;
	marker_2.id = 1;
	marker_2.lifetime = ros::Duration(0);
	// marker_2.pose.orientation.w = 1.0;
	marker_2.type = visualization_msgs::Marker::LINE_STRIP;
	marker_2.scale.x = 0.1f;
	marker_2.color.r = 1.0f;
	marker_2.color.g = 0.0f;
	marker_2.color.b = 0.0f;
	marker_2.color.a = 1.0f;
	markerArray.markers.push_back(marker_2);
	return markerArray;
}
/*
Extract time, position, and velocity of each agent and write them to a vector of RVO::AgentTraj.
*/
void log_sim_data(RVO::RVOSimulator *sim, std::vector<RVO::AgentTraj>& agentTrajVec)
{
	for (size_t i = 0; i < sim->getNumAgents(); i++){
		agentTrajVec[i].log_data(sim->getGlobalTime(),sim->getAgentPosition(i),sim->getAgentVelocity(i),sim->getAgentPrefVelocity(i));
	}
}


int main(int argc, char **argv)
{
	ros::init (argc, argv, "example");
	ros::NodeHandle nh = ros::NodeHandle("~");
	ros::Publisher pub_marker = nh.advertise<visualization_msgs::Marker> ("marker_agents",1);
	ros::Publisher pub_marker_obs = nh.advertise<visualization_msgs::MarkerArray> ("marker_obstacle",1);

	/* Create a new simulator instance. */
	RVO::RVOSimulator *sim = new RVO::RVOSimulator();
	/* Set up the scenario. */
	setupScenario(sim);

	std::vector<RVO::AgentTraj> agentTrajVec;
	for (int i = 0; i < sim->getNumAgents(); i++){
		RVO::AgentTraj tempTraj;
		tempTraj.set_agent_id(i);
		agentTrajVec.push_back(tempTraj);
	}
	// ROS_INFO_STREAM(getObsMarker().ns);

	ros::Rate loop_rate(30);
	while (ros::ok()){
		// updateVisualization(sim);
		pub_marker.publish(getMarkers(sim));
		pub_marker_obs.publish(getObsMarkerArray());

		setPreferredVelocities(sim);
		sim->doStep();
		log_sim_data(sim,agentTrajVec);
		ros::spinOnce();
		loop_rate.sleep();

		if(reachedGoal(sim)){
			for (int i = 0; i < agentTrajVec.size();i++){
				ROS_INFO_STREAM(agentTrajVec[i].time_traj.size());
			}
			delete sim;
			break;
		}
	}
	return 0;
}
